﻿using System;
using System.Windows;
using System.Windows.Media;
using System.Windows.Media.Effects;

namespace ShaderLibrary
{
  public class BlendSwirlEffect : ShaderEffect
  {
    static BlendSwirlEffect()
    {
      _pixelShader.UriSource = Global.MakePackUri("effect1.ps");
    }
    public BlendSwirlEffect()
    {
      this.PixelShader = _pixelShader;

      UpdateShaderValue(InputProperty);
      UpdateShaderValue(Input2Property);
      UpdateShaderValue(SwirlProperty);
    }
    public Brush Input
    {
      get { return (Brush)GetValue(InputProperty); }
      set { SetValue(InputProperty, value); }
    }

    public static readonly DependencyProperty InputProperty =
        ShaderEffect.RegisterPixelShaderSamplerProperty("Input", typeof(BlendSwirlEffect), 0);

    public Brush Input2
    {
      get { return ((Brush)GetValue(Input2Property)); }
      set { SetValue(Input2Property, value); }
    }

    public static readonly DependencyProperty Input2Property =
      ShaderEffect.RegisterPixelShaderSamplerProperty("Input2", typeof(BlendSwirlEffect), 1);

    public double Swirl
    {
      get { return (double)GetValue(SwirlProperty); }
      set { SetValue(SwirlProperty, value); }
    }

    public static readonly DependencyProperty SwirlProperty =
        DependencyProperty.Register("Swirl", typeof(double), typeof(BlendSwirlEffect),
                new UIPropertyMetadata(0.0, PixelShaderConstantCallback(0)));

    public double Blend
    {
      get { return (double)GetValue(BlendProperty); }
      set { SetValue(BlendProperty, value); }
    }

    public static readonly DependencyProperty BlendProperty =
        DependencyProperty.Register("Blend", typeof(double), typeof(BlendSwirlEffect),
                new UIPropertyMetadata(0.0, PixelShaderConstantCallback(1)));

    private static PixelShader _pixelShader = new PixelShader();
  }
}
