float factor : register(C0);
float blend : register(C1);

sampler2D input : register(S0);
sampler2D input2 : register(S1);

float4 main(float2 uv : TEXCOORD) : COLOR
{
  float angle = -3.14;
  float yDist = uv.y - 0.5;
  float xDist = uv.x - 0.5;
  float dist = sqrt(xDist * xDist + yDist * yDist);
  angle *= dist * factor;

  float xN = cos(angle) * xDist - sin(angle) * yDist;
  float yN = sin(angle) * xDist + cos(angle) * yDist;
  uv.x = xN + 0.5;
  uv.y = yN + 0.5;
  float4 img1Colour = tex2D(input, uv);  
  float4 img2Colour = tex2D(input2, uv);
  img1Colour *= blend;
  img2Colour *= (1.0 - blend);
  img2Colour += img1Colour;
  
  return(img2Colour);
}


